<template>
    <div class="w-screen h-screen bg-dark text-white px-2 overflow-y-scroll fixed">
        <div
            class="mx-auto text-center py-6 cursor-pointer"
            @click="$router.push({name: 'user.auth.login'})"
        >
            <img
                :src="'/img/logo.png'"
                class="h-24 mx-auto text-center"
            >
        </div>
        <template
            v-if="step === 2"
        >
            <div
                class="text-center font-bold capitalize text-2xl mb-3"
            >
                {{ $t('please_check_your_email') }}
            </div>
            <div
                class="text-center text-gray-400 text-xs"
                v-html="computedResetEmailMessage"
            />
            <div
                class="my-12"
            >
                <auto-button
                    class="text-2xl tracking-wider"
                    @click="$router.push({name: 'user.auth.login'})"
                >
                    {{ $t('login') }}
                </auto-button>
            </div>
        </template>
        <template
            v-else
        >
            <div
                class="text-center font-bold capitalize text-2xl"
            >
                {{ $t('forget_password') }}
            </div>
            <div
                class="text-center text-gray-400 text-xs mb-12"
            >
                {{ $t('please_provide_your_registered_email_to_obtain_reset_password_link') }}
            </div>
            <div
                class="py-2"
            >
                <auto-form
                    ref="form"
                    :fields="fields"
                    :dark="true"
                    size="lg"
                    @form-update="onFormUpdate"
                />
                <div
                    class="my-12"
                >
                    <auto-button
                        class="text-2xl tracking-wider"
                        :busy="form && form.busy ? form.busy : false"
                        :disabled="form && form.busy ? form.busy : false"
                        @click="submitForm"
                    >
                        {{ $t('reset') }}
                    </auto-button>
                </div>
            </div>
        </template>
    </div>
</template>

<script setup>
import {computed, inject, ref} from "vue";
import {useRouter} from 'vue-router';
import AutoForm from '~/components/auto-form.vue';
import {useI18n} from "vue-i18n";
import AutoButton from "~/components/button/auto-button.vue";

const $router = useRouter();
const $helper = inject('$helper');

const {t} = useI18n();
const step = ref(1);
const form = ref();
const cloneEmail = ref('');
const fields = [
    {type: 'email', name: 'email', label: t('email'), placeholder: 'abc@ask.com', dark: true, size: 'lg'},
];

const computedResetEmailMessage = computed(() => {
    return String(t('reset_email_sent_message')).replace(/___EMAIL___/i, '<span class="text-blue-500 underline">' + (cloneEmail.value) + '</span>');
});

const submitForm = async () => {
    try {
        const resp = await form.value.submitForm('/forget_password');
        step.value = 2;
    } catch (e) {
        console.log(e);
    }
}

const onFormUpdate = (fd) => {
    if (fd.get('email')) {
        cloneEmail.value = fd.get('email');
    }
};
</script>
